// TWI Salve2

#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <inttypes.h>



// um Register auch bitweise in Binrformat ansprechen zu knnen
#define BIN8(b7,b6,b5,b4,b3,b2,b1,b0) ((unsigned char)\
                          (b0 << 0)\
                        | (b1 << 1)\
                        | (b2 << 2)\
                        | (b3 << 3)\
                        | (b4 << 4)\
                        | (b5 << 5)\
                        | (b6 << 6)\
                        | (b7 << 7))

#define SLAVE_ADR  5					// define own slave adress


volatile unsigned char twi_val1;

int main (void) 
{

	PORTB=BIN8(1,1,1,1,0,1,1,0); 		// pull up PINs... (nur wenn in DDR als Eingang def)
	PORTC=BIN8(1,0,0,1,1,1,1,1); 		// pull up PINs... (nur wenn in DDR als Eingang def)
	PORTD=BIN8(0,0,1,1,1,0,1,1); 		// pull up PINs... (nur wenn in DDR als Eingang def) 
	
	DDRB=  BIN8(0,0,0,0,1,0,0,1);		// Datenrichtung PortB 	0=Eingang 1=Ausgang
	DDRC=  BIN8(0,0,0,0,0,0,0,0);		// Datenrichtung PortC
	DDRD=  BIN8(1,1,0,0,0,1,0,0);		// Datenrichtung PortD
	
	
	// TWI-Schnittstelle initialisieren  Slave Transmitter Mode
	TWAR=0;
	TWAR|= (SLAVE_ADR<<1); 	// Receiver adress
	TWCR = (1<<TWEN)|(1<<TWEA)|(1<<TWIE)|(1<<TWINT);  
	
	// TWEN : TWI Enable
	// TWSTA : 1=master 0=slave
	// TWEA : TWI Enable Acknowledge Bit
	// TWIE : TWI Interrupt Enable
	
  
	sei();

	for (;;){asm volatile ("nop");}
	
	return 0;
} 





SIGNAL(SIG_2WIRE_SERIAL) 
{  
	switch (TWSR)
	{
		//****************************************
		// Slave status (receiver mode)
		
		case(0x60):{ // Own SLA+W has been received; ACK has been returned
			TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);	// In next action: Data byte will be received and ACK will be returned
			break;
		} 
		
		case(0x80):{ // Previously addressed with own SLA+W; data has been received; ACK has been returned
			twi_val1=TWDR;
			TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
			break;
		}
		
		case(0xA0):{   //A STOP condition or repeated START condition has been received while still addressed as Slave
			//i2c_val2=TWDR;  // nicht zweimal lesen!!
			TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
			break;
		} 





		//****************************************
		// Slave status (transmitter mode)
 
		case(0xA8):{ //Own SLA+R has been received; ACK has been returned
			TWDR=twi_val1;
			TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
			break;	
		}
		case(0xC0):{  // Data byte in TWDR has been transmitted; NOT ACK has been received
			TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
			break;	
		}
	}	
}










